/*-------------------------------------------------------------------------
//                           UNCLASSIFIED
/*-------------------------------------------------------------------------
RAYTHEON PROPRIETARY: THIS DOCUMENT CONTAINS DATA OR INFORMATION
PROPRIETARY TO RAYTHEON COMPANY AND IS RESTRICTED TO USE ONLY BY PERSONS
AUTHORIZED BY RAYTHEON COMPANY IN WRITING TO USE IT. DISCLOSURE TO
UNAUTHORIZED PERSONS WOULD LIKELY CAUSE SUBSTANTIAL COMPETITIVE HARM TO
RAYTHEON COMPANY'S BUSINESS POSITION. NEITHER SAID DOCUMENT NOR ITS
CONTENTS SHALL BE FURNISHED OR DISCLOSED TO OR COPIED OR USED BY PERSONS
OUTSIDE RAYTHEON COMPANY WITHOUT THE EXPRESS WRITTEN APPROVAL OF RAYTHEON
COMPANY.

THIS PROPRIETARY NOTICE IS NOT APPLICABLE IF DELIVERED TO THE U.S.
GOVERNMENT.

UNPUBLISHED WORK - COPYRIGHT RAYTHEON COMPANY.
-------------------------------------------------------------------------*/
using NLog;
using ProgramLib.GUI.Model;
using ProgramLib.GUI.View;
using System;
using System.Collections.Generic;
using System.Threading;

namespace ProgramLib
{
   /// <summary>
   /// Class to spawn thread to update power supply data on GUI
   /// </summary>
   internal class PowerSupplyUpdateThread : BasicThread
   {
      private enum Events
      {
         GLOBAL_QUIT,
         UUT_POWER_ON,
         UUT_POWER_OFF,

         // DO NOT change the name
         // This must be the last member in the enum
         EVENT_TIMED_OUT
      }

      private ILogger _logger;
      private LiveDataWindow _mainWindow;

      private Dictionary<string, PowerModuleDataModel> _powerModuleToPowerDataModelDict = new Dictionary<string, PowerModuleDataModel>();

      /// <summary>
      /// Constructor
      /// </summary>
      public PowerSupplyUpdateThread()
      {
         _logger = LogManager.GetCurrentClassLogger();

         _mainWindow = (LiveDataWindow)ProgramLib.Program.Instance().GetGuiManager()[ProgramGuiManager.WINDOWS.LIVE_DATA];

         _powerModuleToPowerDataModelDict["UUT_P20V"] = new PowerModuleDataModel();
         _powerModuleToPowerDataModelDict["UUT_N20V"] = new PowerModuleDataModel();

         ProgramLib.Program.Instance().GetGuiManager()[ProgramGuiManager.WINDOWS.LIVE_DATA].Dispatcher.Invoke((Action)delegate
         {
            _mainWindow.LiveDataWindowViewModel.AddPowerData(_powerModuleToPowerDataModelDict);
         });
      }

      ~PowerSupplyUpdateThread()
      {
         _logger?.Debug($"Entering {this.GetType().Name}::{System.Reflection.MethodBase.GetCurrentMethod().Name}() ...");
      }

      /// <summary>
      /// Method that executes on the thread.
      /// </summary>
      /// <param name=""></param>
      /// <returns></returns>
      protected override void DoWork()
      {
         _logger?.Debug($"{this.GetType().Name}::{System.Reflection.MethodBase.GetCurrentMethod().Name}() is running...");

         try
         {
            Dictionary<Events, EventWaitHandle> eventDict = new Dictionary<Events, EventWaitHandle>();
            eventDict[Events.GLOBAL_QUIT] = Program.Instance().EventManager[EventManager.Events.GLOBAL_QUIT];
            eventDict[Events.UUT_POWER_ON] = Program.Instance().EventManager[EventManager.Events.UUT_POWER_ON];
            eventDict[Events.EVENT_TIMED_OUT] = null;

            EventGroup<Events, EventWaitHandle> eventGroup = new EventGroup<Events, EventWaitHandle>(eventDict);

            while (true)
            {
               Events id = eventGroup.WaitAny();

               if (id == Events.UUT_POWER_ON)
               {
                  UpdatePowerSupplyData();
               }
               else
                  break;
            }
         }
         catch (Exception ex)
         {
            _logger?.Error(ex.Message + "\n" + ex.StackTrace);
         }

         _logger?.Debug($"{this.GetType().Name}::{System.Reflection.MethodBase.GetCurrentMethod().Name}() is exiting...");

      }

      /// <summary>
      /// Log and update GUI with power supply data
      /// </summary>
      /// <param name=""></param>
      /// <returns></returns>
      private void UpdatePowerSupplyData()
      {
         int pollRateMs = 1000;
         _logger?.Debug($"{this.GetType().Name}::{System.Reflection.MethodBase.GetCurrentMethod().Name}() is running...");

         try
         {
            Dictionary<Events, EventWaitHandle> eventDict = new Dictionary<Events, EventWaitHandle>();
            eventDict[Events.GLOBAL_QUIT] = Program.Instance().EventManager[EventManager.Events.GLOBAL_QUIT];
            eventDict[Events.UUT_POWER_OFF] = Program.Instance().EventManager[EventManager.Events.UUT_POWER_OFF];
            eventDict[Events.EVENT_TIMED_OUT] = null;

            EventGroup<Events, EventWaitHandle> eventGroup = new EventGroup<Events, EventWaitHandle>(eventDict);

            while (true)
            {
               Events id = eventGroup.WaitAny(pollRateMs);

               if (id == Events.EVENT_TIMED_OUT)
               {
                  PowerSupplyData data = Program.Instance().PowerSupplySharedData.GetData("STE_PVM_5V");

                  if (data != null && data.Initialized)
                  {
                     _powerModuleToPowerDataModelDict["UUT_P20V"].ActualVoltage = data.Voltage.ToString("0.00");
                     _powerModuleToPowerDataModelDict["UUT_P20V"].ExpectedVoltage = data.PowerSupplyModuleInfo.voltageSetpoint_.ToString("0.00");
                     _powerModuleToPowerDataModelDict["UUT_P20V"].ActualCurrent = data.Current.ToString("0.00");

                     _powerModuleToPowerDataModelDict["UUT_N20V"].ActualVoltage = data.Voltage.ToString("0.00");
                     _powerModuleToPowerDataModelDict["UUT_N20V"].ExpectedVoltage = data.PowerSupplyModuleInfo.voltageSetpoint_.ToString("0.00");
                     _powerModuleToPowerDataModelDict["UUT_N20V"].ActualCurrent = data.Current.ToString("0.00");
                  }
               }
               else
                  break;
            }
         }
         catch (Exception ex)
         {
            _logger.Error(ex.Message + "\n" + ex.StackTrace);
         }

         _logger?.Debug($"{this.GetType().Name}::{System.Reflection.MethodBase.GetCurrentMethod().Name}() is exiting...");
      }
   }
}
